﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: True
#End Region

'Service module
Sub Process_Globals
	Type miniClock(centerX As Float, centerY As Float, radius As Float, oldHands() As Float)

	Dim rv As RemoteViews
	Dim bitmap1 As Bitmap

	Private wholeClock As Rect
	Private separators(2) As Rect
	
	Private miniClocks(4, 2, 3) As miniClock
	Private digits(10, 2, 3, 2) As Float
	Private clockTimer As  Timer
	Private firstTime As Boolean
	Private lastSeconds As Int
End Sub

Sub Service_Create
	firstTime = True
	createDigits
	bitmap1.InitializeMutable(200, 75)	'ignore

	rv = ConfigureHomeWidget("A", "rv", 0, "NSS Clock", False)
	clockTimer.Initialize("clockTimer", 1000)
	Dim w As Float = 200
	Dim h As Float = 75
	Dim r As Float = w / 16
	wholeClock.Initialize( 0, 0, w, w)
	Dim sz As Float = 1dip
	separators(0).Initialize(.5 * w - sz, .5 * h - r - sz, .5 * w + sz, .5 * h - r + sz)
	separators(1).Initialize(.5 * w - sz, .5 * h + r - sz, .5 * w + sz, .5 * h + r + sz)
	Dim yoffset As Float = (h - 6 * r) / 2
	For k = 0 To 3
		For i = 0 To 1
			For j = 0 To 2
				miniClocks(k, i, j) = newMiniClock(r + (k * 2 + i) * (2 * r), yoffset + r + j * (2 * r), r, Array As Float(0, 3))
			Next
		Next
	Next
	
	Dim N As Notification
	N.Initialize
	N.Number=1
	N.Light=False
	N.Sound=False
	N.Vibrate=False
	N.Icon = "icon"
	clockTimer.enabled = True
	N.SetInfo("NSS Clock Widget", "This is the Service for the NSSClock Widget", Main)
	Service.StartForeground(1,N)
End Sub

Sub Service_Start (StartingIntent As Intent)
	If rv.HandleWidgetEvents(StartingIntent) Then Return
End Sub

Sub clockTimer_Tick
	Dim theTime As Long = DateTime.Now
	Dim seconds As Int = DateTime.getSecond(theTime)
	If seconds < lastSeconds Or firstTime Then
		clockTimer.Enabled = False
		Dim cv As Canvas
		cv.Initialize2(bitmap1)
		cv.AntiAlias=True

		firstTime = False
		Dim hrs As Int = DateTime.getHour(theTime)
		Dim mins As Int = DateTime.getMinute(theTime)
		If hrs > 12 Then hrs = hrs - 12
		If hrs = 0 Then hrs = 12
		Dim d() As Int = Array As Int(hrs / 10, hrs Mod 10, mins / 10, mins Mod(10))
		For i = 0 To 120
			If updateWidget(d, cv) = True Then Exit
			Sleep(80)
		Next
		fadeAndSeparate(cv)
		Sleep(500)
	End If
	lastSeconds = seconds
	clockTimer.Enabled = True
End Sub

Private Sub updateWidget(d() As Int, cv As Canvas) As Boolean
	cv.DrawColor(Colors.Transparent)
	Dim cnt As Int = 0
	For position = 0 To 3
		For i = 0 To 1
			For j = 0 To 2
				For m = 0 To 1
					If moveTo(miniClocks(position, i, j), digits(d(position), i, j, m), m, cv) Then cnt = cnt + 1
				Next
			Next
		Next
	Next
	rv.SetImage("ImageView1", cv.Bitmap)
	rv.UpdateWidget
	Return cnt = 48
End Sub

Private Sub moveTo(clock As miniClock, finalPosition As Float, hand As Int, cv As Canvas) As Boolean
	Dim angle As Float
	Dim fromPosition As Float = clock.oldHands(hand)
	Dim done As Boolean 
	If Abs(fromPosition - finalPosition) > .05 Then
		fromPosition = fromPosition + .1
		angle = 30 * (fromPosition - 3)
		If fromPosition > 12 Then fromPosition = fromPosition - 12
		clock.oldHands(hand) = fromPosition
	Else
		angle = 30 * (fromPosition - 3)
		done = True 
	End If
	Dim newX As Float = clock.centerX + clock.radius * CosD(angle)
	Dim newY As Float = clock.centerY + clock.radius * SinD(angle)
	cv.DrawLine(clock.centerX, clock.centerY, newX, newY, Colors.White, 1dip)
	Return done
End Sub

Sub rv_RequestUpdate
End Sub

Sub rv_Disabled
	StopService("")
End Sub

Sub Service_Destroy
End Sub

Private Sub fadeAndSeparate(cv As Canvas)
	For stp = 0 To 30
		For k = 0 To 3
			For i = 0 To 1
				For j = 0 To 2
					For m = 0 To 1
						Dim clock As miniClock = miniClocks(k, i, j)
						Dim pos As Float = clock.oldHands(m)
						Dim sevenThirty As Float = Abs(7.5 - pos)
						If sevenThirty < .05 Then
							Dim angle As Float = 30 * (pos - 3)
							Dim newX As Float = clock.centerX + clock.radius * CosD(angle)
							Dim newY As Float = clock.centerY + clock.radius * SinD(angle)
							cv.DrawLine(clock.centerX, clock.centerY, newX, newY, Colors.ARGB(35, 200, 200, 220), 1dip)
						End If
					Next
				Next
			Next
		Next
		cv.DrawRect(separators(0), Colors.Argb(35, 255, 255, 255), True, 0)
		cv.DrawRect(separators(1), Colors.Argb(35, 255, 255, 255), True, 0)
		rv.SetImage("ImageView1", cv.Bitmap)
		rv.UpdateWidget
		Sleep(80)
	Next
End Sub

Private Sub createDigits
	createOneDigit(0, Array As Float(3, 6, 9, 6, 0, 6, 0, 6, 0, 3, 0, 9))
	createOneDigit(1, Array As Float(7.5, 7.5, 6, 6, 7.5, 7.5, 0, 6, 7.5, 7.5, 0, 0))
	createOneDigit(2, Array As Float(3, 3, 9, 6, 3, 6, 0, 9, 0, 3, 9, 9))
	createOneDigit(3, Array As Float(3, 3, 9, 6, 3, 3, 0, 6, 3, 3, 0, 9))
	createOneDigit(4, Array As Float(6, 6, 6, 6, 0, 3, 6, 9, 7.5, 7.5, 0, 0))
	createOneDigit(5, Array As Float(3, 6, 9, 9, 0, 3, 9, 6, 3, 3, 0, 9))
	createOneDigit(6, Array As Float(6, 6, 7.5, 7.5, 0, 3, 9, 6, 0, 3, 0, 9))
	createOneDigit(7, Array As Float(3, 3, 9, 6, 7.5, 7.5, 0, 6, 7.5, 7.5, 0, 0))
	createOneDigit(8, Array As Float(3, 6, 9, 6, 0, 3, 9, 0, 0, 3, 0, 9))
	createOneDigit(9, Array As Float(3, 6, 9, 6, 0, 3, 9, 0, 3, 3, 0, 9))
End Sub

Private Sub createOneDigit(digit As Int, spec() As Float)
	Dim m As Int = -1
	For j = 0 To 2
		For i = 0 To 1
			For k = 0 To 1
				m = m + 1
				digits(digit, i, j, k) = spec(m)
			Next
		Next
	Next
End Sub

Public Sub newMiniClock (centerX As Float, centerY As Float, radius As Float, oldHands() As Float) As miniClock
	Dim t1 As miniClock
	t1.Initialize
	t1.centerX = centerX
	t1.centerY = centerY
	t1.radius = radius
	t1.oldHands = oldHands
	Return t1
End Sub
